package J2EEApp;

import java.sql.*;

import javax.sql.*;
import javax.naming.*;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

public class BankMgrEJB implements SessionBean
{
    private static final String loginQuery = "SELECT USERID FROM J2EEAPPUSER WHERE USERNAME = ? AND PASSWORD = ?";
    private javax.sql.DataSource jdbcFactory;

    // SessionBean implementation
    public void ejbActivate() { }
    public void ejbPassivate() { }
    public void ejbCreate() 
    {
	try {
	    Context initialContext = new InitialContext();
	    jdbcFactory = (DataSource)initialContext.lookup("jdbc/BankMgrDB");
	} catch (NamingException ne) {
	    System.out.println("NamingException:\n" + ne.getMessage());
	}
    }
    public void ejbPostCreate() { }
    public void ejbRemove() { }
    public void setSessionContext(SessionContext ctx) { }

    // Bean methods
    public String loginUser(String pUsername, String pPassword)
    {
	System.out.println("loginUser: " + pUsername + ", " + pPassword + "\n");

	String userID = null;
	Connection conn = null;
	PreparedStatement ps = null;
	ResultSet rs = null;
	try {
	    conn = jdbcFactory.getConnection();
	    ps = conn.prepareStatement(loginQuery);
	    ps.setString(1, pUsername);
	    ps.setString(2, pPassword);
	    rs = ps.executeQuery();
	    if (rs !=  null && rs.next()) {
		userID = rs.getString("USERID").trim();
		
	    } else {
		System.out.println("loginUser: No USERID found\n");
	    }
	} catch (SQLException se) {
	    System.out.println("SQL Exception: " + se.getMessage());
	    se.printStackTrace();
	} catch (Exception e) {
	    System.out.println("Exception: " + e.getMessage());
	    e.printStackTrace();
	} finally {
	    try {
		if (rs != null) rs.close();
		if (ps != null) ps.close();
		if (conn != null) conn.close();
	    } catch (SQLException se) { } // ignore here
	}
	return userID;
    }
} // end class
