/* CMSI 688 Homework Set 2, Exercise 4
 * Craig E. Ward 
 * Fall 2002
 */
package J2EEApp;

import java.io.*;

import javax.naming.*;

/**
 * Test client for CustomerData and AccountData beans
 */
public class BankAccess
{
    private BankMgrHome myBankMgrHome = null;

    public static void main (String args[])
    {
	// Supply some test data to create objects and print them
	//	CustomerData cd = new CustomerData("007", "James", "Bond", "555-1234");
	//	AccountData ad = new AccountData("007-001", 200.2, "Special");
	//	System.out.println("CustomerData values: " + cd + "\nAccountData values: " + ad);

	BankAccess ba = new BankAccess();
	ba.runTests();
	System.exit(0);
    }

    private void runTests()
    {
	System.out.println("\tEntering runTests()");
	try {
	    this.initMyBankMgrHome();
	    BankMgr bankMgr = myBankMgrHome.create();
	    System.out.println("\nStart loginUser tests");
	    System.out.println("User: James Bond\tPassword: XXXX\tUserID: " +
			       bankMgr.loginUser("James Bond", "secret"));
	    System.out.println("User: Maxwell Smart\tPassword: XXXX\tUserID: " +
			       bankMgr.loginUser("Maxwell Smart", "shoe"));
	    System.out.println("User: Joe Cool\tPassword: XXXX\tUserID: " +
			       bankMgr.loginUser("Joe Cool", "peanuts"));
	    System.out.println("End loginUser tests");
	    System.out.println("\nStart getCustomerData tests");
	    String customerID = "B";
	    System.out.println("Customer " + customerID + ": " + bankMgr.getCustomerData(customerID));
	    customerID = "A";
	    System.out.println("Customer " + customerID + ": " + bankMgr.getCustomerData(customerID));
	    customerID = "D";
	    System.out.println("Customer " + customerID + ": " + bankMgr.getCustomerData(customerID));
	    System.out.println("End getCustomerData tests");
	    bankMgr.remove(); // clean up EJB
	} catch (Exception e) {
	    System.out.println("Test failed: " + e.getMessage());
	}
	System.out.println("\tLeaving runTests()");
    }

    private void initMyBankMgrHome() throws Exception
    {
	System.out.println("\tEntering initMyBankMgrHome()");

	try {
	    Context initialContext = new InitialContext();
	    myBankMgrHome = (BankMgrHome)initialContext.lookup("bankmgrServer");
	} catch (NamingException ne) {
	    System.out.println("NamingException:\n" + ne.getMessage());
	    throw new Exception();
	}

	System.out.println("\tLeaving initMyBankMgrHome()");
    }
}
