/* CMSI 688 Homework Set 2, Exercise 4++
 * Craig E. Ward 
 * Fall 2002
 */
package J2EEApp;

import java.io.*;
import java.util.*;

import javax.naming.*;

/**
 * Test client Exercise 2 J2EEApp
 */
public class BankAccess
{
    private BankMgrHome myBankMgrHome = null;
    private AccountHome myAccountHome = null;
    private int testNumber = 0;

    public static void main (String args[])
    {
	if (args.length != 1) {
	    System.err.println("usage: J2EEApp.BankAccess <test-number-representing-exercise-number>");
	    System.exit(1);
	}

	BankAccess ba = new BankAccess();
       	ba.setTestNumber(args[0]);
	ba.runTests();
	System.exit(0);
    }

    private void setTestNumber(String numberString)
    {
	Integer integer = new Integer(numberString);
	testNumber = integer.intValue();
    }

    private void runTests()
    {
	System.out.println("Entering BankAccess.runTests()");

	if (testNumber != 2) {
	    try {
		// initialize EJB home references
		this.initMyBankMgrHome();
		this.initMyAccountHome();
	    } catch (Exception e) {
		System.out.println("Exception! Test failed: " + e.getMessage());
		e.printStackTrace();
		System.out.println("Test run aborted!");
		System.exit(1);
	    }
	}
	
	switch (testNumber) 
	    {
	    case 1:
		System.out.println("BankAccess.runTests: No tests for Exercise " + testNumber);
		break;

	    case 2:
		runTest2();
		break;

	    case 3:
		runTest3();
		break;

	    case 4:
		runTest4();
		break;

	    case 5:
		runTest5();
		break;

	    case 6:
		runTest6();
		break;

	    case 7:
		runTest7();
		break;

	    case 8:
		runTest8();
		break;

	    default:
		System.out.println("BankAccess.runTests: Nothing defined for test number " + testNumber);
		break;
	    }

	System.out.println("Leaving BankAccess.runTests()");
    }

    // Individual test methods
    private void runTest2()
    {
	System.out.println("runTest2: Start Data Model Object tests");
	// Supply some test data to create objects and print them (Exercise 2)
	CustomerData cd = new CustomerData("007", "James", "Bond", "555-1234");
	AccountData ad = new AccountData("007-001", 200.2, "Special");
	System.out.println("BankAccess.runTest2: CustomerData values: " + cd + "\nAccountData values: " + ad);
	System.out.println("runTest2: End Data Model Objects tests");
    }

    private void runTest3()
    {
	/* Exercises 3 */
	System.out.println("runTest3: Start loginUser tests");
	BankMgr bankMgr = null;

	try {
	    bankMgr = myBankMgrHome.create();
	    System.out.println("User: James Bond\tPassword: XXXX\tUserID: " +
			       bankMgr.loginUser("James", "secret"));
	    System.out.println("User: Maxwell Smart\tPassword: XXXX\tUserID: " +
			       bankMgr.loginUser("Max", "shoe"));
	    System.out.println("User: Joe Cool\tPassword: XXXX\tUserID: " +
			       bankMgr.loginUser("Joe", "peanuts"));
	    // clean up EJB
	    if (bankMgr != null) bankMgr.remove();
	} catch (Exception e) {
	    System.out.println("Test failed: " + e.getMessage());
	    e.printStackTrace();
	} finally {
	    System.out.println("runTest3: End loginUser tests");
	}
    }

    private void runTest4()
    {
	/* Exerise 4 */

	System.out.println("runTest4: Start getCustomerData tests");
	BankMgr bankMgr = null;
	try {
	    bankMgr = myBankMgrHome.create();
	    String customerID = "B";
	    System.out.println("Customer " + customerID + ": " + bankMgr.getCustomerData(customerID));
	    customerID = "A";
	    System.out.println("Customer " + customerID + ": " + bankMgr.getCustomerData(customerID));
	    customerID = "D";
	    System.out.println("Customer " + customerID + ": " + bankMgr.getCustomerData(customerID));
	    System.out.println("End getCustomerData tests");
	    if (bankMgr != null ) bankMgr.remove();
	} catch (Exception e) {
	    System.out.println("Test failed: " + e.getMessage());
	    e.printStackTrace();
	} finally {
	    System.out.println("runTest4: End Acount tests");
	}
    }

    private void runTest5()
    {
	/* Exercise 5 */
	System.out.println("runTest5: Start Acount tests");
	BankMgr bankMgr = null;
	Account anAccount = null;
	try {
	    bankMgr = myBankMgrHome.create();
	    System.out.println("Account create call");
	    anAccount = myAccountHome.create("1000", "A", "Discover", 10000.00);
	    AccountData acctData = anAccount.getAccountData();
	    System.out.println("Account Data: " + acctData.toString());
	    System.out.println("Account remove call");
	    if (anAccount != null ) anAccount.remove();
	    // clean up EJB
	    if (bankMgr != null ) bankMgr.remove();
	} catch (Exception e) {
	    System.out.println("Test failed: " + e.getMessage());
	    e.printStackTrace();
	} finally {
	    System.out.println("runTest5: End Acount create test");
	}
    }

    private void runTest6()
    {
	/* Exercise 6 */
	System.out.println("runTest6: Finder methods tests");
	BankMgr bankMgr = null;
	try {
	    bankMgr = myBankMgrHome.create();
	/*
	  /java/j2sdkee1.3.1/bin/j2ee: line 14:  1367 Bus error               $JAVACMD $SAX_PROPS $PROPS -classpath "$CPATH" com.sun.enterprise.server.J2EEServer "$@"
	*/
	    System.out.println("Start customerFindAll test");
	    Vector customers = bankMgr.getAllCustomers();
	    displayCustomerVector(customers);
	    System.out.println("End customerFindAll test");

	    System.out.println("\tAccounts of customerID A");	    
	    Collection accounts = myAccountHome.findByCustomerID("A");
	    System.out.println("--==>Created Vector object -- Calling displayAccountsCollection()");
	    displayAccountsCollection(accounts);
	} catch (Exception e) {
	    System.out.println("Test failed: " + e.getMessage());
	    e.printStackTrace();
	} finally {
	    System.out.println("runTest6: End Finder methods tests");
	}
    }

    private void runTest7()
    {
	/* Exercise 7 */
	System.out.println("runTest7: Start CustomerWithAcctsData test");
	BankMgr bankMgr = null;

	try {
	    bankMgr = myBankMgrHome.create();
	    System.out.println("\tAccounts of customerID A");	    
	    CustomerWithAcctsData cwad = bankMgr.getCustomerWithAcctsData("A");
	    System.out.println("\n\t--CustomerWithAcctsData--\n" + cwad.toString() + "\n\t--CustomerWithAcctsData--");
	    // clean up EJB
	    if (bankMgr != null) bankMgr.remove();
	} catch (Exception e) {
	    System.out.println("Test failed: " + e.getMessage());
	    e.printStackTrace();
	} finally {
	    System.out.println("runTest7: End CustomerWithAcctsData test");
	}
    }

    private void runTest8()
    {
	/* Exercise 8 */
	// This aassumes that the custormer ID "A" exists already
	System.out.println("runTest8: Start Acount/Sequencer test");
	Account account = null;
	try {
	    System.out.println("Account create call");
	    account = myAccountHome.create("A", "Discover", 10000.00);
	    AccountData acctdata = account.getAccountData();
	    System.out.println("AccountData: " + acctdata.toString());
	    System.out.println("Account remove call");
	    if (account != null ) account.remove();
	} catch (Exception e) {
	    System.out.println("Test failed: " + e.getMessage());
	    e.printStackTrace();
	} finally {
	    System.out.println("runTest8: End Acount tests");
	}
    }

    /*
      private void runTestX()
      {

      }
    */

    // Support methods 
    private void displayAccountsCollection(Collection acctsVec) 
	throws java.rmi.RemoteException
    {
	System.out.println("---->Entering BankAccess.displayAccountsCollection()");
	System.out.println("---->accounts Vector has " + acctsVec.size() + " elements");
	Iterator i = acctsVec.iterator();
	System.out.println("---->Created Iterator");
	while (i.hasNext()) {
	    System.out.println("---->Iterator hasNext");
	    //AccountData aData = (AccountData)i.next();
	    Account acc = (Account)i.next();
	    AccountData aData = acc.getAccountData();
	    System.out.println("---->Account Data: " + aData);	    
	}

	System.out.println("---->Leaving BankAccess.displayAccountsCollection()");
    }

    private void displayCustomerVector(Collection customers)
    {
	System.out.println("\tEntering displayCustomerVector()");
	System.out.println("\tcustomer Vector has " + customers.size() + " elements");
	Iterator i = customers.iterator();
	while (i.hasNext()) {
	    CustomerData cd = (CustomerData)i.next();
	    System.out.println("***Customer " + cd.toString());
	}
	System.out.println("\tLeaving displayCustomerVector()");
    }

    private void initMyBankMgrHome() throws Exception
    {
	System.out.println("\tEntering initMyBankMgrHome()");

	try {
	    Context initialContext = new InitialContext();
	    Object result = initialContext.lookup("bankmgrServer");
	    myBankMgrHome = (BankMgrHome)javax.rmi.PortableRemoteObject.narrow(result,BankMgrHome.class);
	} catch (NamingException ne) {
	    System.out.println("NamingException:\n" + ne.getMessage());
	    throw new Exception();
	}

	System.out.println("\tLeaving initMyBankMgrHome()");
    } // initMyBankMgrHome

    private void initMyAccountHome() throws Exception
    {
	System.out.println("\tEntering initMyAccountHome()");

	try {
	    Context initialContext = new InitialContext();
	    Object result = initialContext.lookup("accountServer");
	    myAccountHome = (AccountHome)javax.rmi.PortableRemoteObject.narrow(result,AccountHome.class);
	} catch (NamingException ne) {
	    System.out.println("NamingException:\n" + ne.getMessage());
	    throw new Exception();
	}
	System.out.println("\tLeaving initMyAccountHome()");
    } // initMyAccountHome

} // end class BankAccess
