connect 'jdbc:rmi://localhost:1099/jdbc:cloudscape:BankMgrDB;create=true';

DROP TABLE J2EESEQUENCER;
-- DROP TABLE SequencerEJBTable;
DROP TABLE J2EEACCOUNT;
DROP TABLE J2EEAPPUSER;
DROP TABLE J2EECUSTOMER;

CREATE TABLE J2EEAPPUSER (
	USERNAME VARCHAR(20) CONSTRAINT PK_J2EEAPPUSER PRIMARY KEY,
	PASSWORD VARCHAR(20),
	USERID VARCHAR(6));


CREATE TABLE J2EECUSTOMER (
	CUSTOMERID	VARCHAR(6) CONSTRAINT PK_J2EECUSTOMER PRIMARY KEY,
	FIRSTNAME	VARCHAR(20),
	LASTNAME	VARCHAR(20),
	ADDRESS		VARCHAR(50),
	PHONE		VARCHAR(20) );

CREATE TABLE J2EEACCOUNT (
	ACCTNUMBER  VARCHAR(6) CONSTRAINT PK_J2EEACCOUNT PRIMARY KEY,
	CUSTOMERID  VARCHAR(6),
	DESCRIPTION VARCHAR(20),
	BALANCE DECIMAL(12,2),
		CONSTRAINT FK_J2EEACCOUNT_1 FOREIGN KEY (CUSTOMERID) REFERENCES J2EECUSTOMER (CUSTOMERID) );

CREATE TABLE J2EESEQUENCER (
	SEQUENCETYPE VARCHAR(20) CONSTRAINT PK_J2EESEQUENCER PRIMARY KEY,
	SEQUENCEVALUE INT);

-- CREATE TABLE SequencerEJBTable (
-- 	SEQUENCETYPE VARCHAR(20) CONSTRAINT PK_SequencerEBJTable PRIMARY KEY,
--	SEQUENCEVALUE INT);

insert into  J2EESEQUENCER VALUES ('ACCOUNT', 103);
insert into  J2EESEQUENCER VALUES ('APPUSER', 35);
-- insert into  SequencerEJBTable VALUES ('ACCOUNT', 103);
-- insert into  SequencerEJBTable VALUES ('APPUSER', 35);

insert into J2EEAPPUSER (USERNAME, PASSWORD, USERID) values ('Al', 'password', '1');
insert into J2EEAPPUSER (USERNAME, PASSWORD, USERID) values ('James', 'secret', 'A007');
insert into J2EEAPPUSER (USERNAME, PASSWORD, USERID) values ('Max', 'shoe', 'A86');
insert into J2EEAPPUSER (USERNAME, PASSWORD, USERID) values ('Joe', 'peanuts', 'Snoopy');
insert into J2EEAPPUSER (USERNAME, PASSWORD, USERID) values ('Leela', 'pilot', 'A');
insert into J2EEAPPUSER (USERNAME, PASSWORD, USERID) values ('Hermes', 'forms', 'E');
insert into J2EEAPPUSER (USERNAME, PASSWORD, USERID) values ('Fry', 'pizza', 'B');
insert into J2EEAPPUSER (USERNAME, PASSWORD, USERID) values ('Hubert', 'password', 'D');
insert into J2EEAPPUSER (USERNAME, PASSWORD, USERID) values ('Zoidberg', 'doctor', 'F');

insert into J2EECUSTOMER (CUSTOMERID, FIRSTNAME, LASTNAME, ADDRESS, PHONE)
	values ('1','Al', 'Smith', 'Los Angeles', '310-555-1234');
insert into J2EECUSTOMER (CUSTOMERID, FIRSTNAME, LASTNAME, ADDRESS, PHONE)
	values ('A','Turanga', 'Leela', 'New New York', '212-555-1234');
insert into J2EECUSTOMER (CUSTOMERID, FIRSTNAME, LASTNAME, ADDRESS, PHONE)
	values ('B','Philip', 'Fry', 'New New York', '212-555-1234');
insert into J2EECUSTOMER (CUSTOMERID, FIRSTNAME, LASTNAME, ADDRESS, PHONE)
	values ('C','Rodrigeuz', 'BENDER', 'New New York', '202-555-1111');
insert into J2EECUSTOMER (CUSTOMERID, FIRSTNAME, LASTNAME, ADDRESS, PHONE)
	values ('D','Hubert', 'Farnsworth', 'New New York', '211-555-7878');
insert into J2EECUSTOMER (CUSTOMERID, FIRSTNAME, LASTNAME, ADDRESS, PHONE)
	values ('E','Hermes', 'Conrad', 'New New York', '501-555-0661');
insert into J2EECUSTOMER (CUSTOMERID, FIRSTNAME, LASTNAME, ADDRESS, PHONE)
	values ('F','John', 'Zoidberg', 'New New York', '101-555-1776');
insert into J2EECUSTOMER (CUSTOMERID, FIRSTNAME, LASTNAME, ADDRESS, PHONE)
	values ('A007','James', 'Bond', 'London, England', '011-07-55-1234');
insert into J2EECUSTOMER (CUSTOMERID, FIRSTNAME, LASTNAME, ADDRESS, PHONE)
	values ('A86','Maxwell', 'Smart', 'New New York', '210-555-1234');
insert into J2EECUSTOMER (CUSTOMERID, FIRSTNAME, LASTNAME, ADDRESS, PHONE)
	values ('Snoopy','Joe', 'Cool', 'Everytown, USA', '710-555-1234');

insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('10','A','SAVINGS', 10000.00);
insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('20','A','CHECKING', 100.00);
insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('30','B','SAVINGS', 0.10);
insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('50','E','SAVINGS', 50.05);
insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('40','D','SAVINGS', 1000000.10);
insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('60','F','SAVINGS', 99.99);
insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('70','C','CHECKING', 101.01);

insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('11','Snoopy','SAVINGS', 100.00);
insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('21','Snoopy','CHECKING', 10.00);

insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('12','A007','SAVINGS', 700000.07);
insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('22','A007','CHECKING', 70007.07);

insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('13','A86','SAVINGS', 86000.00);
insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('23','A86','CHECKING', 8600.00);

insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('14','1','SAVINGS', 10000.00);
insert into J2EEACCOUNT (ACCTNUMBER, CUSTOMERID, DESCRIPTION, BALANCE)
	values ('24','1','CHECKING', 100.00);

disconnect;
